// polymorphisme
// In polymorfisme worden de objecten van de parent of superclass "Vormen" gedeclareerd.
// Je kan zeggen, een vorm kan een vierkant of een cirkel zijn. dit is polymorfisme
// Dit i.t.t inheritance waar de objecten van de sub of child class worden gedeclareerd.
Vormen[] vormen = new Vormen[30];  // Een array van 30 objecten declareren
//Vierkant vierkant;  Natuurlijk mag je ook een child object declareren

void setup() {
  size(480, 270);

  for (int i = 0; i < vormen.length/2; i++ ) {
    //Het initieeren van de vorm objecten. Hier geef je de beginwaarden en vorm (cirkel of vierkant) aan
    //Dus een vorm object kan zowel een vierkant als een cirkel zijn.  
    //De cellen 0 t/m 14 van de array bevatten cirkels
    vormen[i] = new Cirkel(width/2, height/2, 50, color(random(255), random(255), random(255), 100));
  } 
  //De cellen 15 t/m 30 van de array bevatten vierkantjes
  for (int i = vormen.length/2; i < vormen.length; i++ ) {
    vormen[i] = new Vierkant(width/4, height/2, 32);
  }
}

void draw() {
  background(255);
  // trillen en display van alle vormen
  for (int i = 0; i < vormen.length; i++ ) {
    vormen[i].trillen();  //trillen staat in de Vormen en de Vierkant class     
    vormen[i].display(); 
    //de display methoden van Cirkel en Vierkant overschrijven de display methode van de parent class.
    //Als de child classes geen display methode hebben, wordt display van de parent class gebruikt.
    //In de class Vierkant een trillen methode toegevoegd, deze wordt dus overschreven door trillen in parent.
  }
}